#include "Arduino.h"
#include "RobotAlbert.h"




/*void RobotAlbertNano::begin(){
 
}*/
///////////////////////////////////////
void RobotAlbertNano::moveForward(int speed){
 int movespeed = (float)speed*255/100; 
 LeftMotor.run(_Lcal*movespeed);
 RightMotor.run(_Rcal*movespeed);
}
////
void RobotAlbertNano::moveBack(int speed){
int  movespeed = (float)speed*255/100; 
 LeftMotor.run(-movespeed*_Lcal);
 RightMotor.run(-movespeed*_Rcal);	
}
////////////////////////////////////////////
 void RobotAlbertNano::moveForward(int leftspeed,int rightspeed)
 {
 	int Lspeed = _Lcal*leftspeed*255/100;
 	int Rspeed = _Rcal*rightspeed*255/100;
 	LeftMotor.run(Lspeed);
 	RightMotor.run(Rspeed);
 }

 void RobotAlbertNano::moveRight(int speed)
 {
//int rspeed;
//rspeed = speed*255/100; 	
moveForward(_Rcal*speed,0);

 }
 ///
 void RobotAlbertNano::moveLeft(int speed)
 {
//int rspeed;
//rspeed = speed*255/100; 	
moveForward(0,_Lcal*speed);
 }
 
//////////////////////////////
void RobotAlbertNano::stop()
{
	LeftMotor.stop();
  RightMotor.stop();
}
///////////////////////////////
///////////////////////////////
void RobotAlbertNano::turnRight(int speed){
int turnspeed = (float)speed*255/100;

LeftMotor.run(_Lcal*turnspeed);
RightMotor.run(-turnspeed*_Rcal);

}
/////////////////////////////////////////
void RobotAlbertNano::turnRight(int speed,int time)
{
int turnspeed = (float)speed*255/100;
int i = 0;

LeftMotor.run(_Lcal*turnspeed);
RightMotor.run(-turnspeed*_Rcal);
for (i=0;i<time;i++)
 {
  delay(100);
 }
 stop();
 delay(200);
}
/////////////////////
void RobotAlbertNano::turnLeft(int speed){
int turnspeed = (float)speed*255/100;
//LeftMotor.stop();
//RightMotor.stop();
//delayMicroseconds(deadband_time);
	 LeftMotor.run(-turnspeed*_Lcal);
	 RightMotor.run(turnspeed*_Rcal);
//delay(turn_duration_time);
//LeftMotor.stop();
//RightMotor.stop();
//delay(deadband_time);
}
//////////
void RobotAlbertNano::turnLeft(int speed,int time)
{
int turnspeed = (float)speed*255/100;
int i = 0;

LeftMotor.run(-turnspeed*_Lcal);
RightMotor.run(turnspeed*_Rcal);

for (i=0;i<time;i++)
 {
  delay(100);
 }
 stop();
 delay(200);

}
////////////////////////////////
void RobotAlbertNano::setup_lineSensor(int color, int threshold_detect){
_LINE_COLOR = color;
_line_detect = threshold_detect; 
pinMode(lineSensor_enable,OUTPUT);
}

//////////////////////////////////
int RobotAlbertNano::readSensor(int channel)
{
digitalWrite(lineSensor_enable,HIGH);
 int line_value = analogRead(channel);
digitalWrite(lineSensor_enable,LOW);

 return line_value;
}
///////////////////////////////////////////////////////
bool RobotAlbertNano::leftSensor(){
bool color;	
int value;
digitalWrite(lineSensor_enable,HIGH);
value = analogRead(leftline_pin);
digitalWrite(lineSensor_enable,LOW);

color  =  _LINE_COLOR; 
   if (color == BLACK) 
    {
     if (value>_line_detect) return 1;
     else return 0;
    }
   else 
   {
      if (value<_line_detect) return 1;
      else return 0;
   }
}
////////////////////////////////////////////////////////
bool RobotAlbertNano::rightSensor(){
bool color;
int value;		

digitalWrite(lineSensor_enable,HIGH);
 value = analogRead(rightline_pin);
digitalWrite(lineSensor_enable,LOW);

 color  =  _LINE_COLOR; 
   if (color == BLACK) 
    {
     if (value>_line_detect) return 1;
     else return 0;
    }
   else 
   {
      if (value<_line_detect) return 1;
      else return 0;
   }

}
///////////////////////////////////////////////////
bool RobotAlbertNano::centerSensor(){
bool color;
int value;	

digitalWrite(lineSensor_enable,HIGH);
 value = analogRead(centerline_pin);
digitalWrite(lineSensor_enable,LOW);
 
 color  =  _LINE_COLOR; 
   if (color == BLACK) 
    {
     if (value>_line_detect) return 1;
     else return 0;
    }
   else 
   {
      if (value<_line_detect) return 1;
      else return 0;
   }
}

///////////////////////////////////
float RobotAlbertNano::readSonar() {
  float range = Distance.Ranging(CM);
  delay(100);
return range;
    }
 /////////////////////////////////////////////////////////////////////////////////   
 void RobotAlbertNano::setServo(int Angle)
{
// if (!servo.attached) 
servo.attach(Servo_Pin);
 servo.write(Angle);
}
/*
 //////////////////////////////////
 
void RobotAlbert::lookright()
{
	
Headservo.attach(Servo1_pin);   	
Headservo.write(Right_angle);
delay(500);
Headservo.detach();//release for using PWM on Pin 9,10


}

//////
void RobotAlbert::lookleft()
{

Headservo.attach(Servo1_pin); 	
Headservo.write(Left_angle);
delay(500);
Headservo.detach();//release for using PWM on Pin 9,10


}
///
void RobotAlbert::lookfront()
{

Headservo.attach(Servo1_pin); 
Headservo.write(Center_angle);
delay(500);
Headservo.detach();//release for using PWM on Pin 9,10


}

*/
