#include "AlbertMotor.h"


AlbertMotorL9110::AlbertMotorL9110(int PinA,int PinB)
{  
    _PinA = PinA;
    _PinB = PinB;
   pinMode(_PinA,OUTPUT);
   pinMode(_PinB,OUTPUT);
}
////////////////////////////////////////////////////////////////////////
void AlbertMotorL9110::run(int speed)
{    
    speed = speed > 255 ? 255 : speed;   // if speed > 255 -> speed = 255
    speed = speed < -255 ? -255 : speed; // if speed < -255 -> speed = -255
   
    // constrain(speed,-255,255);
    if(speed >= 0) {
        analogWrite(_PinB,0);
        analogWrite(_PinA,speed);
    } 
    else {
        analogWrite(_PinA,0);
        analogWrite(_PinB,-speed);
    }
}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
void AlbertMotorL9110::stop()
{
    analogWrite(_PinB,0);
    analogWrite(_PinA,0);
   // delay(deadband);
}   



 AlbertMotorL293::AlbertMotorL293(int PWM,int Dir)
{  
    _PWM = PWM;
    _Dir = Dir;
   pinMode(_PWM,OUTPUT);
   pinMode(_Dir,OUTPUT);
}
////////////////////////////////////////////////////////////////////////
void AlbertMotorL293::run(int speed)
{    
    speed = speed > 255 ? 255 : speed;   // if speed > 255 -> speed = 255
    speed = speed < -255 ? -255 : speed; // if speed < -255 -> speed = -255
   
    // constrain(speed,-255,255);
    if(speed >= 0) {
        digitalWrite(_Dir,0);
        analogWrite(_PWM,speed);
    } 
    else {
        digitalWrite(_Dir,1);
        analogWrite(_PWM,-speed);
    }
}
/////////////////////////////////////////////////////////////////////////
void AlbertMotorL293::stop()
{
    digitalWrite(_Dir,0);
    analogWrite(_PWM,0);
   // delay(deadband);
}   
